/**
 ******************************************************************************
 * @project  LM35 temperature sensor example 
 * @author   Edward Ahn, Jim Jun
 * @version  V1.0.1
 * @date     26-MAY-2016
 * @brief    Analog Pin Control
*******************************************************************************
**/
const int sensorPin = A2;   // 온도 센서 선언

int val = 0;          // 온도 측정 값 넣을 변수
float voltage = 0;    // 전압 계산 값 넣을 변수
float celsius = 0;    // 섭씨 계산 값 넣을 변수
float Fahrenheit = 0; // 화씨 계산 값 넣을 변수

void setup() {
  SerialUSB.begin(9600); // Serial initial
}

void loop() {
  // read the value from the sensor:
  val = analogRead(sensorPin);
  // 실제 전압 계산
  // 0~3.3V의 값을 구하기 위해 아래와 같이 3.3를 곱하고 4096를 나눈다.
  // (Analog값 * IC에 걸리는 전압 / Analog 12bit 분해능(4096))
  // IC에 걸리는 전압은 측정기로 측정
  voltage = val * 3.3 / 4096.0;
  // LM35는 섭씨 1도당 10mV의 전위차를 갖는다.
  // 센서핀의 전압이 0.28V라면 280mV이므로 온도는 28도씨.
  // 100을 곱해서 섭씨 온도로 나타냄
  celsius = voltage * 100.0;
  // 섭씨에서 화씨 환산 -> (화씨온도 = 섭씽온*9/5+32)
  Fahrenheit = celsius * 9.0/5.0 + 32.0;
  delay(1000);
  SerialUSB.print("Sensor value :");
  SerialUSB.println(val);                
  SerialUSB.print("Volt : ");
  SerialUSB.print(voltage);
  SerialUSB.println("mV");
  SerialUSB.print("celsius temp : ");
  SerialUSB.print(celsius);
  SerialUSB.println("c");
  SerialUSB.print("Fahrenheit temp : ");
  SerialUSB.print(Fahrenheit);
  SerialUSB.println("F");
  delay(1000);
}
