/**
 ******************************************************************************
 * @project  illumination sensor example
 * @author   Edward Ahn, Jim Jun
 * @version  V1.0.1
 * @date     26-MAY-2016
 * @brief    Digital Pin Control
*******************************************************************************
**/

/*
CDS센서는 빛의 양에 따라 저항값이 변하며 포토레지스러, 일반적으로 광센서라 불린다.
CDS센서(포토레지스터)의 저항값은 최소 수 ㏀에서 최대 수십 ㏁까지 변한다.
포토레지스터는 가격이 저렴하여 간단하게 활용할 수 있지만 반응속도가 느리고 광량에 
따른 출력 특성이 정밀하지 않다는 단점이 있다.

어두운 곳에서는 높은 저항값을 가지지만 밝은 곳에서는 저항값이 낮아진다.

일상적인 광량에서는 대략 430 전후의 값이, 손으로 광센서를 완전히 가리면 950
전후의 값이 출력되는 것을 확인할 수 있다.
*/
const int sensorPin = A1; // 조도 센서 A1 선언   
const int ledPin = 13; // LED D13 선언     
int val = 0; // 조도 값을 읽고 읽은 값을 계산해서 저장할 변수 선언

void setup() {
  pinMode(ledPin, OUTPUT); // LED 출력으로 지정

  // Open serial communications and wait for port to open:
  //SerialUSB.begin(9600);
  //while (!SerialUSB) {
  //  ; // wait for serial port to connect. Needed for Leonardo only
  //}
}

void loop() {
  //map : 특정 범위에 속하는 값을 다른 범위의 값으로 변환해주는 명령어
  val = map(analogRead(sensorPin), 0, 1023, 0, 255);
  //val = (analogRead(sensorPin) * 3.3v); // 다른 계산 방법
  if(val > 128){ // 조도 저항 값이 낮기 때문에 아날로그 값이 높음
    digitalWrite(ledPin, LOW); 
  }
  else{ // 손가락으로 가리면 조도 저항값이 높아지기 때문에 아날로그 값이 낮아진다
    digitalWrite(ledPin, HIGH);
  }
  
  //SerialUSB.println(val);
}
